#include "mousex.h"

BOOL CheckMousex(CHAR *src) {
    //      
    //  -  ,     ^_^
    CHAR *org = "\\??\\Root#RDP_MOU#0000#";
    for (UINT i = 0; i < 22; i++) {
        if (src[i] != org[i]) {
            return FALSE;
        }
    }
    return TRUE;
}

UINT InitMousex(HWND target) {
    // -   
    UINT numdevices;
    if (GetRawInputDeviceList(NULL, &numdevices, sizeof(RAWINPUTDEVICELIST)) != 0) {
        return 0;
    }

    //   
    RAWINPUTDEVICELIST *devicelist = new RAWINPUTDEVICELIST[numdevices];
    if (GetRawInputDeviceList(devicelist, &numdevices, sizeof(RAWINPUTDEVICELIST)) == -1) {
        return 0;
    }

    //   ^_^
    ZeroMemory(mouselist, sizeof(RAW_MOUSE) * MAX_MOUSES);

    //  
    UINT size, i;
    CHAR *name;
    nummouses = 0;
    for (i = 0; i < numdevices; i++) {

        //  - 
        if (devicelist[i].dwType == RIM_TYPEMOUSE) {

            //   
            if (GetRawInputDeviceInfo(devicelist[i].hDevice, RIDI_DEVICENAME, NULL, &size) != 0) {
                return 0;
            }

            //   
            name = new CHAR[size];

            // 
            if (GetRawInputDeviceInfo(devicelist[i].hDevice, RIDI_DEVICENAME, name, &size) < 0) {
                return 0;
            }

            //     
            if (!CheckMousex(name)) {

                //  ,     
                mouselist[nummouses++].device_handle = devicelist[i].hDevice;

                //      
                //    ..   
                //        
                if (nummouses >= MAX_MOUSES) {
                    //       
                    //     ^_^
                    delete[] name;
                    break;
                }
                //   
                delete[] name;
            }
        }
    }

    //  
    delete[] devicelist;

    if (nummouses < 1) {
        return 0;
    }

    //  
    RAWINPUTDEVICE rid[1];
    rid[0].usUsagePage = 0x01; 
    rid[0].usUsage = 0x02; 
    rid[0].dwFlags = 0;
    rid[0].hwndTarget = target;
    if (!RegisterRawInputDevices(rid, 1, sizeof(RAWINPUTDEVICE))) {
        return 0;
    }
    return nummouses;
}

VOID ReadMousex(RAWINPUT *raw) {
    //   
    for (UINT i = 0; i < nummouses; i++) {
        //       
        if (mouselist[i].device_handle == raw->header.hDevice) {
            //    - 
            if (mouselist[i].is_absolute) {
                mouselist[i].x = raw->data.mouse.lLastX;
                mouselist[i].y = raw->data.mouse.lLastY;
            } else {
                //   - 
                mouselist[i].x += raw->data.mouse.lLastX;
                mouselist[i].y += raw->data.mouse.lLastY;
            }
            //  ^_^
            if (raw->data.mouse.usButtonFlags & RI_MOUSE_BUTTON_1_DOWN) {
                mouselist[i].buttonpressed[0] = 1;
            }
            if (raw->data.mouse.usButtonFlags & RI_MOUSE_BUTTON_1_UP) {
                mouselist[i].buttonpressed[0] = 0;
            }
            if (raw->data.mouse.usButtonFlags & RI_MOUSE_BUTTON_2_DOWN) {
                mouselist[i].buttonpressed[1] = 1;
            }
            if (raw->data.mouse.usButtonFlags & RI_MOUSE_BUTTON_2_UP) {
                mouselist[i].buttonpressed[1] = 0;
            }
            if (raw->data.mouse.usButtonFlags & RI_MOUSE_BUTTON_3_DOWN) {
                mouselist[i].buttonpressed[2] = 1;
            }
            if (raw->data.mouse.usButtonFlags & RI_MOUSE_BUTTON_3_UP) {
                mouselist[i].buttonpressed[2] = 0;
            }
            //   
            if (raw->data.mouse.usFlags & MOUSE_MOVE_ABSOLUTE) {
                mouselist[i].is_absolute = 1;
            } else if (raw->data.mouse.usFlags & MOUSE_MOVE_RELATIVE) {
                mouselist[i].is_absolute = 0;
            }
            //  -    ,   - ^_^
            if (raw->data.mouse.usFlags & MOUSE_VIRTUAL_DESKTOP) {
                mouselist[i].is_virtual_desktop = 1;
            } else {
                mouselist[i].is_virtual_desktop = 0;
            }
            //  ^_^
            if (raw->data.mouse.usButtonFlags & RI_MOUSE_WHEEL) {
                if ((SHORT)raw->data.mouse.usButtonData > 0) {
                    mouselist[i].z++;
                }
                if ((SHORT)raw->data.mouse.usButtonData < 0) {
                    mouselist[i].z--;
                }
            }
        }
    }
}

BOOL UpdateMousex(HRAWINPUT device) {
    //    
    UINT size;
    if (GetRawInputData(device, RID_INPUT, NULL, &size, sizeof(RAWINPUTHEADER)) == -1) {
        return FALSE;
    }
    // 
    BYTE *data = new BYTE[size];
    // 
    if (GetRawInputData(device, RID_INPUT, data, &size, sizeof(RAWINPUTHEADER)) != size) {
        return FALSE;
    }
    //   
    ReadMousex((RAWINPUT *)data);
    // 
    delete[] data;
    return TRUE;
}

LRESULT WindowCallback(HWND window, UINT message, WPARAM wparam, LPARAM lparam) {
    //  WM_INPUT
    if (message == WM_INPUT) {
        UpdateMousex((HRAWINPUT)lparam);
    }
    // ()  
    return CallWindowProc(callback, window, message, wparam, lparam);
}

EXPORT UINT CreateMousex(HWND window) {
    if (window) {
        //       
        callback = (WNDPROC)SetWindowLong(window, GWL_WNDPROC, (LONG)WindowCallback);
        if (callback) {
            target = window;
            return InitMousex(window);
        }
    }
    return 0;
}

EXPORT VOID DeleteMousex() {
    if ((target) && (callback)) {
        //   
        SetWindowLong(target, GWL_WNDPROC, (LONG)callback);
        target = NULL;
        callback = NULL;
    }
}

EXPORT BOOL MousexDown(UINT mouse, UINT button) {
    return mouselist[mouse].buttonpressed[button];
}

EXPORT ULONG MousexDeltaX(UINT mouse) {
    ULONG result = mouselist[mouse].x;
    if (!mouselist[mouse].is_absolute) {
        mouselist[mouse].x = 0;
    }
    return result;
}

EXPORT ULONG MousexDeltaY(UINT mouse) {
    ULONG result = mouselist[mouse].y;
    if (!mouselist[mouse].is_absolute) {
        mouselist[mouse].y = 0;
    }
    return result;
}

EXPORT ULONG MousexDeltaZ(UINT mouse) {
    ULONG result = mouselist[mouse].z;
    if (!mouselist[mouse].is_absolute) {
        mouselist[mouse].z = 0;
    }
    return result;
}

BOOL CALLBACK DllMain(HINSTANCE instance, DWORD reason, LPVOID reserved) {
    switch (reason) {
        case DLL_PROCESS_ATTACH:
            break;
        case DLL_PROCESS_DETACH:
            //   ,     
            //  Memory Access Violation,      ""
            DeleteMousex();
            break;
        case DLL_THREAD_ATTACH:
            break;
        case DLL_THREAD_DETACH:
            break;
    }
    return TRUE;
}
